<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArtigoArmazemERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArtigoArmazemERP
 * @subpackage Arrays
 */
class ArrayOfArtigoArmazemERP extends AbstractStructArrayBase
{
    /**
     * The ArtigoArmazemERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ArtigoArmazemERP[]
     */
    public $ArtigoArmazemERP;
    /**
     * Constructor method for ArrayOfArtigoArmazemERP
     * @uses ArrayOfArtigoArmazemERP::setArtigoArmazemERP()
     * @param \StructType\ArtigoArmazemERP[] $artigoArmazemERP
     */
    public function __construct(array $artigoArmazemERP = array())
    {
        $this
            ->setArtigoArmazemERP($artigoArmazemERP);
    }
    /**
     * Get ArtigoArmazemERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ArtigoArmazemERP[]|null
     */
    public function getArtigoArmazemERP()
    {
        return isset($this->ArtigoArmazemERP) ? $this->ArtigoArmazemERP : null;
    }
    /**
     * Set ArtigoArmazemERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ArtigoArmazemERP[] $artigoArmazemERP
     * @return \ArrayType\ArrayOfArtigoArmazemERP
     */
    public function setArtigoArmazemERP(array $artigoArmazemERP = array())
    {
        foreach ($artigoArmazemERP as $arrayOfArtigoArmazemERPArtigoArmazemERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfArtigoArmazemERPArtigoArmazemERPItem instanceof \StructType\ArtigoArmazemERP) {
                throw new \InvalidArgumentException(sprintf('The ArtigoArmazemERP property can only contain items of \StructType\ArtigoArmazemERP, "%s" given', is_object($arrayOfArtigoArmazemERPArtigoArmazemERPItem) ? get_class($arrayOfArtigoArmazemERPArtigoArmazemERPItem) : gettype($arrayOfArtigoArmazemERPArtigoArmazemERPItem)), __LINE__);
            }
        }
        if (is_null($artigoArmazemERP) || (is_array($artigoArmazemERP) && empty($artigoArmazemERP))) {
            unset($this->ArtigoArmazemERP);
        } else {
            $this->ArtigoArmazemERP = $artigoArmazemERP;
        }
        return $this;
    }
    /**
     * Add item to ArtigoArmazemERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ArtigoArmazemERP $item
     * @return \ArrayType\ArrayOfArtigoArmazemERP
     */
    public function addToArtigoArmazemERP(\StructType\ArtigoArmazemERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ArtigoArmazemERP) {
            throw new \InvalidArgumentException(sprintf('The ArtigoArmazemERP property can only contain items of \StructType\ArtigoArmazemERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArtigoArmazemERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ArtigoArmazemERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ArtigoArmazemERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ArtigoArmazemERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ArtigoArmazemERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ArtigoArmazemERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArtigoArmazemERP
     */
    public function getAttributeName()
    {
        return 'ArtigoArmazemERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfArtigoArmazemERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
